Add XEN_CMD to _autoconf.py
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Use bash in order to be able to use pipefail
18 SHELL=/bin/bash
19
20 ACLOCAL_AMFLAGS = -I autotools
21 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
22 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
23 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
24 CHECK_HEADER = $(top_srcdir)/autotools/check-header
25 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
26 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
27 CHECK_VERSION = $(top_srcdir)/autotools/check-version
28 CHECK_NEWS = $(top_srcdir)/autotools/check-news
29 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
30 DOCPP = $(top_srcdir)/autotools/docpp
31 REPLACE_VARS_SED = autotools/replace_vars.sed
32 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
33 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
34
35 # Note: these are automake-specific variables, and must be named after
36 # the directory + 'dir' suffix
37 clientdir = $(pkgpythondir)/client
38 hypervisordir = $(pkgpythondir)/hypervisor
39 httpdir = $(pkgpythondir)/http
40 masterddir = $(pkgpythondir)/masterd
41 confddir = $(pkgpythondir)/confd
42 rapidir = $(pkgpythondir)/rapi
43 serverdir = $(pkgpythondir)/server
44 watcherdir = $(pkgpythondir)/watcher
45 impexpddir = $(pkgpythondir)/impexpd
46 utilsdir = $(pkgpythondir)/utils
47 toolsdir = $(pkglibdir)/tools
48 iallocatorsdir = $(pkglibdir)/iallocators
49 pytoolsdir = $(pkgpythondir)/tools
50 docdir = $(datadir)/doc/$(PACKAGE)
51 myexeclibdir = $(pkglibdir)
52
53 # Delete output file if an error occurred while building it
54 .DELETE_ON_ERROR:
55
56 HTOOLS_DIRS = \
57         htools \
58         htools/Ganeti \
59         htools/Ganeti/Confd \
60         htools/Ganeti/HTools \
61         htools/Ganeti/HTools/Program
62
63 DIRS = \
64         autotools \
65         daemons \
66         devel \
67         doc \
68         doc/examples \
69         doc/examples/hooks \
70         doc/examples/gnt-debug \
71         $(HTOOLS_DIRS) \
72         lib \
73         lib/client \
74         lib/build \
75         lib/confd \
76         lib/http \
77         lib/hypervisor \
78         lib/impexpd \
79         lib/masterd \
80         lib/rapi \
81         lib/server \
82         lib/tools \
83         lib/utils \
84         lib/watcher \
85         man \
86         qa \
87         test \
88         test/data \
89         test/data/htools \
90         test/data/htools/rapi \
91         test/data/ovfdata \
92         test/data/ovfdata/other \
93         tools
94
95 BUILDTIME_DIR_AUTOCREATE = \
96         scripts \
97         $(APIDOC_DIR) \
98         $(APIDOC_PY_DIR) \
99         $(APIDOC_HS_DIR) \
100         $(APIDOC_HS_DIR)/Ganeti \
101         $(APIDOC_HS_DIR)/Ganeti/Confd \
102         $(APIDOC_HS_DIR)/Ganeti/HTools \
103         $(APIDOC_HS_DIR)/Ganeti/HTools/Program \
104         $(COVERAGE_DIR) \
105         $(COVERAGE_PY_DIR) \
106         $(COVERAGE_HS_DIR) \
107         .hpc
108
109 BUILDTIME_DIRS = \
110         $(BUILDTIME_DIR_AUTOCREATE) \
111         doc/html
112
113 DIRCHECK_EXCLUDE = \
114         $(BUILDTIME_DIRS) \
115         ganeti-[0-9]*.[0-9]*.[0-9]* \
116         doc/html/_*
117
118 all_dirfiles = $(addsuffix /.dir,$(DIRS) $(BUILDTIME_DIR_AUTOCREATE))
119
120 # some helper vars
121 COVERAGE_DIR = doc/coverage
122 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
123 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
124 APIDOC_DIR = doc/api
125 APIDOC_PY_DIR = $(APIDOC_DIR)/py
126 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
127
128 MAINTAINERCLEANFILES = \
129         $(docpng) \
130         $(maninput) \
131         doc/install-quick.rst \
132         doc/news.rst \
133         doc/upgrade.rst \
134         vcs-version
135
136 maintainer-clean-local:
137         rm -rf $(BUILDTIME_DIRS)
138
139 CLEANFILES = \
140         $(addsuffix /*.py[co],$(DIRS)) \
141         $(addsuffix /*.hi,$(HTOOLS_DIRS)) \
142         $(addsuffix /*.o,$(HTOOLS_DIRS)) \
143         $(all_dirfiles) \
144         $(PYTHON_BOOTSTRAP) \
145         epydoc.conf \
146         autotools/replace_vars.sed \
147         daemons/daemon-util \
148         daemons/ganeti-cleaner \
149         devel/upload \
150         $(BUILT_EXAMPLES) \
151         doc/examples/bash_completion \
152         lib/_generated_rpc.py \
153         $(man_MANS) \
154         $(manhtml) \
155         tools/kvm-ifup \
156         stamp-srclinks \
157         $(nodist_pkgpython_PYTHON) \
158         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
159         $(HS_BUILT_TEST_HELPERS) \
160         .hpc/*.mix htools/*.tix \
161         doc/hs-lint.html
162
163 # BUILT_SOURCES should only be used as a dependency on phony targets. Otherwise
164 # it'll cause the target to rebuild every time.
165 BUILT_SOURCES = \
166   $(built_base_sources) \
167         $(BUILT_PYTHON_SOURCES) \
168         $(PYTHON_BOOTSTRAP)
169
170 built_base_sources = \
171         ganeti \
172         stamp-srclinks \
173         $(all_dirfiles)
174
175 built_python_base_sources = \
176         lib/_autoconf.py \
177         lib/_vcsversion.py
178
179 BUILT_PYTHON_SOURCES = \
180         $(built_python_base_sources) \
181         lib/_generated_rpc.py
182
183 # Generating the RPC wrappers depends on many things, so make sure it's built at
184 # the end of the built sources
185 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
186
187 # these are all built from the underlying %.in sources
188 BUILT_EXAMPLES = \
189         doc/examples/ganeti-kvm-poweroff.initd \
190         doc/examples/ganeti.cron \
191         doc/examples/ganeti.initd \
192         doc/examples/gnt-config-backup \
193         doc/examples/hooks/ipsec
194
195 nodist_pkgpython_PYTHON = \
196         $(BUILT_PYTHON_SOURCES)
197
198 noinst_PYTHON = \
199         lib/build/__init__.py \
200         lib/build/sphinx_ext.py \
201         lib/build/shell_example_lexer.py
202
203 pkgpython_PYTHON = \
204         lib/__init__.py \
205         lib/asyncnotifier.py \
206         lib/backend.py \
207         lib/bdev.py \
208         lib/bootstrap.py \
209         lib/cli.py \
210         lib/cmdlib.py \
211         lib/compat.py \
212         lib/config.py \
213         lib/constants.py \
214         lib/daemon.py \
215         lib/errors.py \
216         lib/ht.py \
217         lib/jqueue.py \
218         lib/jstore.py \
219         lib/locking.py \
220         lib/luxi.py \
221         lib/mcpu.py \
222         lib/netutils.py \
223         lib/objects.py \
224         lib/opcodes.py \
225         lib/ovf.py \
226         lib/qlang.py \
227         lib/query.py \
228         lib/rpc.py \
229         lib/rpc_defs.py \
230         lib/runtime.py \
231         lib/serializer.py \
232         lib/ssconf.py \
233         lib/ssh.py \
234         lib/storage.py \
235         lib/uidpool.py \
236         lib/workerpool.py
237
238 client_PYTHON = \
239         lib/client/__init__.py \
240         lib/client/gnt_backup.py \
241         lib/client/gnt_cluster.py \
242         lib/client/gnt_debug.py \
243         lib/client/gnt_group.py \
244         lib/client/gnt_instance.py \
245         lib/client/gnt_job.py \
246         lib/client/gnt_node.py \
247         lib/client/gnt_os.py
248
249 hypervisor_PYTHON = \
250         lib/hypervisor/__init__.py \
251         lib/hypervisor/hv_base.py \
252         lib/hypervisor/hv_chroot.py \
253         lib/hypervisor/hv_fake.py \
254         lib/hypervisor/hv_kvm.py \
255         lib/hypervisor/hv_lxc.py \
256         lib/hypervisor/hv_xen.py
257
258 rapi_PYTHON = \
259         lib/rapi/__init__.py \
260         lib/rapi/baserlib.py \
261         lib/rapi/client.py \
262         lib/rapi/client_utils.py \
263         lib/rapi/connector.py \
264         lib/rapi/rlib2.py \
265         lib/rapi/testutils.py
266
267 http_PYTHON = \
268         lib/http/__init__.py \
269         lib/http/auth.py \
270         lib/http/client.py \
271         lib/http/server.py
272
273 confd_PYTHON = \
274         lib/confd/__init__.py \
275         lib/confd/client.py \
276         lib/confd/querylib.py \
277         lib/confd/server.py
278
279 masterd_PYTHON = \
280         lib/masterd/__init__.py \
281         lib/masterd/instance.py
282
283 impexpd_PYTHON = \
284         lib/impexpd/__init__.py
285
286 watcher_PYTHON = \
287         lib/watcher/__init__.py \
288         lib/watcher/nodemaint.py \
289         lib/watcher/state.py
290
291 server_PYTHON = \
292         lib/server/__init__.py \
293         lib/server/confd.py \
294         lib/server/masterd.py \
295         lib/server/noded.py \
296         lib/server/rapi.py
297
298 pytools_PYTHON = \
299         lib/tools/__init__.py \
300         lib/tools/ensure_dirs.py
301
302 utils_PYTHON = \
303         lib/utils/__init__.py \
304         lib/utils/algo.py \
305         lib/utils/filelock.py \
306         lib/utils/hash.py \
307         lib/utils/io.py \
308         lib/utils/log.py \
309         lib/utils/mlock.py \
310         lib/utils/nodesetup.py \
311         lib/utils/process.py \
312         lib/utils/retry.py \
313         lib/utils/text.py \
314         lib/utils/wrapper.py \
315         lib/utils/x509.py
316
317 docrst = \
318         doc/admin.rst \
319         doc/design-2.0.rst \
320         doc/design-2.1.rst \
321         doc/design-2.2.rst \
322         doc/design-2.3.rst \
323         doc/design-htools-2.3.rst \
324         doc/design-2.4.rst \
325         doc/design-2.5.rst \
326         doc/design-draft.rst \
327         doc/design-oob.rst \
328         doc/design-cpu-pinning.rst \
329         doc/design-query2.rst \
330         doc/design-x509-ca.rst \
331         doc/design-http-server.rst \
332         doc/design-impexp2.rst \
333         doc/design-lu-generated-jobs.rst \
334         doc/design-multi-reloc.rst \
335         doc/design-network.rst \
336         doc/design-chained-jobs.rst \
337         doc/design-ovf-support.rst \
338         doc/design-resource-model.rst \
339         doc/cluster-merge.rst \
340         doc/design-shared-storage.rst \
341         doc/design-node-state-cache.rst \
342         doc/design-virtual-clusters.rst \
343         doc/devnotes.rst \
344         doc/glossary.rst \
345         doc/hooks.rst \
346         doc/iallocator.rst \
347         doc/index.rst \
348         doc/install-quick.rst \
349         doc/install.rst \
350         doc/locking.rst \
351         doc/move-instance.rst \
352         doc/news.rst \
353         doc/rapi.rst \
354         doc/security.rst \
355         doc/upgrade.rst \
356         doc/walkthrough.rst
357
358 HS_PROGS = htools/htools
359 HS_BIN_ROLES = hbal hscan hspace hinfo
360
361 HS_ALL_PROGS = $(HS_PROGS) htools/test htools/hpc-htools htools/hconfd
362 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
363 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/%) test/hail
364
365 HFLAGS = -O -Wall -Werror -fwarn-monomorphism-restriction -fwarn-tabs -ihtools
366 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
367 HEXTRA =
368 # internal extra flags (used for htools/test mainly)
369 HEXTRA_INT =
370 # exclude options for coverage reports
371 HPCEXCL = --exclude Main \
372         --exclude Ganeti.Constants \
373         --exclude Ganeti.THH \
374         --exclude Ganeti.HTools.QC \
375         --exclude Ganeti.HTools.QCHelper \
376         --exclude Ganeti.HTools.Version
377
378 HS_LIB_SRCS = \
379         htools/Ganeti/HTools/CLI.hs \
380         htools/Ganeti/HTools/Cluster.hs \
381         htools/Ganeti/HTools/Compat.hs \
382         htools/Ganeti/HTools/Container.hs \
383         htools/Ganeti/HTools/ExtLoader.hs \
384         htools/Ganeti/HTools/Group.hs \
385         htools/Ganeti/HTools/IAlloc.hs \
386         htools/Ganeti/HTools/Instance.hs \
387         htools/Ganeti/HTools/JSON.hs \
388         htools/Ganeti/HTools/Loader.hs \
389         htools/Ganeti/HTools/Luxi.hs \
390         htools/Ganeti/HTools/Node.hs \
391         htools/Ganeti/HTools/PeerMap.hs \
392         htools/Ganeti/HTools/QC.hs \
393         htools/Ganeti/HTools/QCHelper.hs \
394         htools/Ganeti/HTools/Rapi.hs \
395         htools/Ganeti/HTools/Simu.hs \
396         htools/Ganeti/HTools/Text.hs \
397         htools/Ganeti/HTools/Types.hs \
398         htools/Ganeti/HTools/Utils.hs \
399         htools/Ganeti/HTools/Program.hs \
400         htools/Ganeti/HTools/Program/Hail.hs \
401         htools/Ganeti/HTools/Program/Hbal.hs \
402         htools/Ganeti/HTools/Program/Hinfo.hs \
403         htools/Ganeti/HTools/Program/Hscan.hs \
404         htools/Ganeti/HTools/Program/Hspace.hs \
405         htools/Ganeti/BasicTypes.hs \
406         htools/Ganeti/Confd.hs \
407         htools/Ganeti/Confd/Server.hs \
408         htools/Ganeti/Config.hs \
409         htools/Ganeti/Daemon.hs \
410         htools/Ganeti/Hash.hs \
411         htools/Ganeti/Jobs.hs \
412         htools/Ganeti/Logging.hs \
413         htools/Ganeti/Luxi.hs \
414         htools/Ganeti/Objects.hs \
415         htools/Ganeti/OpCodes.hs \
416         htools/Ganeti/Runtime.hs \
417         htools/Ganeti/Ssconf.hs \
418         htools/Ganeti/THH.hs
419
420 HS_BUILT_SRCS = htools/Ganeti/HTools/Version.hs htools/Ganeti/Constants.hs
421 HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
422
423 $(RUN_IN_TEMPDIR): | $(all_dirfiles)
424
425 # Note: we use here an order-only prerequisite, as the contents of
426 # _autoconf.py are not actually influencing the html build output: it
427 # has to exist in order for the sphinx module to be loaded
428 # successfully, but we certainly don't want the docs to be rebuilt if
429 # it changes
430 doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
431         $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
432         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
433         | $(BUILT_PYTHON_SOURCES)
434         @test -n "$(SPHINX)" || \
435             { echo 'sphinx-build' not found during configure; exit 1; }
436         @mkdir_p@ $(dir $@)
437         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(SPHINX) -q -W -b html \
438             -d . \
439             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
440             -D release="$(PACKAGE_VERSION)" \
441             $(abs_top_srcdir)/doc $(CURDIR)/doc/html
442         rm -f doc/html/.buildinfo doc/html/objects.inv
443         touch $@
444
445 doc/html: doc/html/index.html
446
447 doc/install-quick.rst: INSTALL
448 doc/news.rst: NEWS
449 doc/upgrade.rst: UPGRADE
450
451 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
452         set -e; \
453         { echo '.. This file is automatically updated at build time from $<.'; \
454           echo '.. Do not edit.'; \
455           echo; \
456           cat $<; \
457         } > $@
458
459 docdot = \
460         doc/arch-2.0.dot \
461         doc/design-2.1-lock-acquire.dot \
462         doc/design-2.1-lock-release.dot
463
464 docpng = $(patsubst %.dot,%.png,$(docdot))
465
466 # Things to build but not to install (add it to EXTRA_DIST if it should be
467 # distributed)
468 noinst_DATA = \
469         devel/upload \
470         doc/html \
471         $(BUILT_EXAMPLES) \
472         doc/examples/bash_completion \
473         $(manhtml)
474
475 gnt_scripts = \
476         scripts/gnt-backup \
477         scripts/gnt-cluster \
478         scripts/gnt-debug \
479         scripts/gnt-group \
480         scripts/gnt-instance \
481         scripts/gnt-job \
482         scripts/gnt-node \
483         scripts/gnt-os
484
485 PYTHON_BOOTSTRAP_SBIN = \
486         daemons/ganeti-masterd \
487         daemons/ganeti-noded \
488         daemons/ganeti-watcher \
489         daemons/ganeti-rapi \
490         $(gnt_scripts)
491
492 if PY_CONFD
493 PYTHON_BOOTSTRAP_SBIN += daemons/ganeti-confd
494 endif
495
496 PYTHON_BOOTSTRAP = \
497         $(PYTHON_BOOTSTRAP_SBIN) \
498         tools/ensure-dirs
499
500 qa_scripts = \
501         qa/__init__.py \
502         qa/ganeti-qa.py \
503         qa/qa_cluster.py \
504         qa/qa_config.py \
505         qa/qa_daemon.py \
506         qa/qa_env.py \
507         qa/qa_error.py \
508         qa/qa_group.py \
509         qa/qa_instance.py \
510         qa/qa_job.py \
511         qa/qa_node.py \
512         qa/qa_os.py \
513         qa/qa_rapi.py \
514         qa/qa_tags.py \
515         qa/qa_utils.py
516
517 bin_SCRIPTS =
518 if WANT_HTOOLS
519 bin_SCRIPTS += $(filter-out htools/hail,$(HS_PROGS))
520 install-exec-hook:
521         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
522 # FIXME: this is a hardcoded logic, instead of auto-resolving
523         $(LN_S) -f ../../../bin/htools \
524                    $(DESTDIR)$(iallocatorsdir)/hail
525         for role in $(HS_BIN_ROLES); do \
526                 $(LN_S) -f htools \
527                            $(DESTDIR)$(bindir)/$$role ; \
528         done
529 if HS_CONFD
530         mv $(DESTDIR)$(sbindir)/hconfd $(DESTDIR)$(sbindir)/ganeti-confd
531 endif
532 endif
533
534 $(HS_ALL_PROGS): %: %.hs $(HS_LIB_SRCS) $(HS_BUILT_SRCS) Makefile
535         @if [ -z "$(HTOOLS)" ]; then \
536           echo "Error: htools compilation disabled at configure time" 1>&2 ;\
537           exit 1; \
538         fi
539         @BINARY=$(@:htools/%=%); \
540         if [ "$BINARY" = "test" ] && [ -z "$(GHC_PKG_QUICKCHECK)" ]; then \
541           echo "Error: cannot run unittests without the QuickCheck library (see devnotes.rst)" 1>&2; \
542           exit 1; \
543         fi
544         rm -f $(@:htools/%=%).tix
545         BINARY=$(@:htools/%=%); $(GHC) --make \
546           $(HFLAGS) \
547           $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) \
548           -osuf $$BINARY.o -hisuf $$BINARY.hi \
549           $(HEXTRA) $(HEXTRA_INT) $@
550 # for the htools/test binary, we need to enable profiling/coverage
551 htools/test: HEXTRA_INT=-fhpc -Wwarn -fno-warn-missing-signatures \
552         -fno-warn-monomorphism-restriction -fno-warn-orphans \
553         -fno-warn-missing-methods -fno-warn-unused-imports
554
555 # we compile the hpc-htools binary with the program coverage
556 htools/hpc-htools: HEXTRA_INT=-fhpc
557
558 # test dependency
559 htools/offline-tests.sh: htools/hpc-htools
560
561 # rules for building profiling-enabled versions of the haskell
562 # programs: hs-prof does the full two-step build, whereas
563 # hs-prof-quick does only the final rebuild (hs-prof must have been
564 # run before)
565 .PHONY: hs-prof hs-prof-quick
566 hs-prof:
567         $(MAKE) clean
568         $(MAKE) $(HS_ALL_PROGS) HEXTRA="-osuf .o"
569         rm -f $(HS_ALL_PROGS)
570         $(MAKE) hs-prof-quick
571
572 hs-prof-quick:
573         $(MAKE) $(HS_ALL_PROGS) HEXTRA="-osuf .prof_o -prof -auto-all"
574
575 dist_sbin_SCRIPTS = \
576         tools/ganeti-listrunner
577
578 nodist_sbin_SCRIPTS = \
579         $(PYTHON_BOOTSTRAP_SBIN) \
580         daemons/ganeti-cleaner
581
582 if HS_CONFD
583 nodist_sbin_SCRIPTS += htools/hconfd
584 endif
585
586 python_scripts = \
587         tools/burnin \
588         tools/cfgshell \
589         tools/cfgupgrade \
590         tools/cfgupgrade12 \
591         tools/cluster-merge \
592         tools/confd-client \
593         tools/fmtjson \
594         tools/lvmstrap \
595         tools/move-instance \
596         tools/ovfconverter \
597         tools/setup-ssh \
598         tools/sanitize-config
599
600 dist_tools_SCRIPTS = \
601         $(python_scripts) \
602         tools/kvm-console-wrapper \
603         tools/xm-console-wrapper \
604         tools/master-ip-setup
605
606 pkglib_python_scripts = \
607         daemons/import-export \
608         tools/check-cert-expired
609
610 nodist_pkglib_python_scripts = \
611         tools/ensure-dirs
612
613 myexeclib_SCRIPTS = \
614         daemons/daemon-util \
615         tools/kvm-ifup \
616         $(pkglib_python_scripts)
617
618 nodist_myexeclib_SCRIPTS = \
619         $(nodist_pkglib_python_scripts)
620
621 EXTRA_DIST = \
622         NEWS \
623         UPGRADE \
624         epydoc.conf.in \
625         pylintrc \
626         autotools/build-bash-completion \
627         autotools/build-rpc \
628         autotools/check-header \
629         autotools/check-python-code \
630         autotools/check-imports \
631         autotools/check-man-dashes \
632         autotools/check-man-warnings \
633         autotools/check-news \
634         autotools/check-tar \
635         autotools/check-version \
636         autotools/convert-constants \
637         autotools/docpp \
638         autotools/gen-coverage \
639         autotools/testrunner \
640         autotools/wrong-hardcoded-paths \
641         $(RUN_IN_TEMPDIR) \
642         daemons/daemon-util.in \
643         daemons/ganeti-cleaner.in \
644         $(pkglib_python_scripts) \
645         devel/upload.in \
646         tools/kvm-ifup.in \
647         $(docdot) \
648         $(docpng) \
649         $(docrst) \
650         doc/conf.py \
651         doc/html \
652         $(BUILT_EXAMPLES:%=%.in) \
653         doc/examples/ganeti.default \
654         doc/examples/ganeti.default-debug \
655         doc/examples/hooks/ethers \
656         doc/examples/gnt-debug/README \
657         doc/examples/gnt-debug/delay0.json \
658         doc/examples/gnt-debug/delay50.json \
659         test/lockperf.py \
660         test/testutils.py \
661         test/mocks.py \
662         $(dist_TESTS) \
663         $(TEST_FILES) \
664         man/footer.rst \
665         $(manrst) \
666         $(maninput) \
667         qa/qa-sample.json \
668         $(qa_scripts) \
669         $(HS_LIB_SRCS) $(HS_BUILT_SRCS_IN) \
670         $(HS_PROG_SRCS) \
671         htools/lint-hints.hs \
672         htools/cli-tests-defs.sh \
673         htools/offline-test.sh
674
675 man_MANS = \
676         man/ganeti.7 \
677         man/ganeti-cleaner.8 \
678         man/ganeti-confd.8 \
679         man/ganeti-listrunner.8 \
680         man/ganeti-masterd.8 \
681         man/ganeti-noded.8 \
682         man/ganeti-os-interface.7 \
683         man/ganeti-rapi.8 \
684         man/ganeti-watcher.8 \
685         man/gnt-backup.8 \
686         man/gnt-cluster.8 \
687         man/gnt-debug.8 \
688         man/gnt-group.8 \
689         man/gnt-instance.8 \
690         man/gnt-job.8 \
691         man/gnt-node.8 \
692         man/gnt-os.8 \
693         man/hail.1 \
694         man/hbal.1 \
695         man/hinfo.1 \
696         man/hscan.1 \
697         man/hspace.1 \
698         man/htools.1
699
700 manrst = $(patsubst %.1,%.rst,$(patsubst %.7,%.rst,$(patsubst %.8,%.rst,$(man_MANS))))
701 manhtml = $(patsubst %.rst,%.html,$(manrst))
702 mangen = $(patsubst %.rst,%.gen,$(manrst))
703 maninput = \
704         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
705         $(patsubst %.html,%.html.in,$(manhtml)) \
706         man/footer.man man/footer.html $(mangen)
707
708 TEST_FILES = \
709         test/data/bdev-drbd-8.0.txt \
710         test/data/bdev-drbd-8.3.txt \
711         test/data/bdev-drbd-disk.txt \
712         test/data/bdev-drbd-net-ip4.txt \
713         test/data/bdev-drbd-net-ip6.txt \
714         test/data/cert1.pem \
715         test/data/ip-addr-show-dummy0.txt \
716         test/data/ip-addr-show-lo-ipv4.txt \
717         test/data/ip-addr-show-lo-ipv6.txt \
718         test/data/ip-addr-show-lo-oneline-ipv4.txt \
719         test/data/ip-addr-show-lo-oneline-ipv6.txt \
720         test/data/ip-addr-show-lo-oneline.txt \
721         test/data/ip-addr-show-lo.txt \
722         test/data/proc_drbd8.txt \
723         test/data/proc_drbd80-emptyline.txt \
724         test/data/proc_drbd83.txt \
725         test/data/proc_drbd83_sync.txt \
726         test/data/proc_drbd83_sync_krnl2.6.39.txt \
727         test/data/kvm_1.0_help.txt \
728         test/data/kvm_0.15.90_help.txt \
729         test/data/kvm_0.12.5_help.txt \
730         test/data/kvm_0.9.1_help.txt \
731         test/data/sys_drbd_usermode_helper.txt \
732         test/data/htools/hail-alloc-drbd.json \
733         test/data/htools/hail-change-group.json \
734         test/data/htools/hail-invalid-reloc.json \
735         test/data/htools/hail-node-evac.json \
736         test/data/htools/hail-reloc-drbd.json \
737         test/data/htools/common-suffix.data \
738         test/data/htools/invalid-node.data \
739         test/data/htools/missing-resources.data \
740         test/data/htools/rapi/groups.json \
741         test/data/htools/rapi/info.json \
742         test/data/htools/rapi/instances.json \
743         test/data/htools/rapi/nodes.json \
744         test/data/ovfdata/compr_disk.vmdk.gz \
745         test/data/ovfdata/config.ini \
746         test/data/ovfdata/corrupted_resources.ovf \
747         test/data/ovfdata/empty.ini \
748         test/data/ovfdata/empty.ovf \
749         test/data/ovfdata/ganeti.mf \
750         test/data/ovfdata/ganeti.ovf \
751         test/data/ovfdata/gzip_disk.ovf \
752         test/data/ovfdata/new_disk.vmdk \
753         test/data/ovfdata/no_disk.ini \
754         test/data/ovfdata/no_disk_in_ref.ovf \
755         test/data/ovfdata/no_os.ini \
756         test/data/ovfdata/no_ovf.ova \
757         test/data/ovfdata/ova.ova \
758         test/data/ovfdata/second_disk.vmdk \
759         test/data/ovfdata/rawdisk.raw \
760         test/data/ovfdata/unsafe_path.ini \
761         test/data/ovfdata/virtualbox.ovf \
762         test/data/ovfdata/wrong_extension.ovd \
763         test/data/ovfdata/wrong_config.ini \
764         test/data/ovfdata/wrong_manifest.mf \
765         test/data/ovfdata/wrong_manifest.ovf \
766         test/data/ovfdata/wrong_ova.ova \
767         test/data/ovfdata/wrong_xml.ovf \
768         test/data/ovfdata/other/rawdisk.raw \
769         test/data/vgreduce-removemissing-2.02.02.txt \
770         test/data/vgreduce-removemissing-2.02.66-fail.txt \
771         test/data/vgreduce-removemissing-2.02.66-ok.txt \
772         test/data/vgs-missing-pvs-2.02.02.txt \
773         test/data/vgs-missing-pvs-2.02.66.txt \
774         test/import-export_unittest-helper \
775         test/gnt-cli.test \
776         test/ganeti-cli.test \
777         test/htools-balancing.test \
778         test/htools-basic.test \
779         test/htools-dynutil.test \
780         test/htools-excl.test \
781         test/htools-hail.test \
782         test/htools-hspace.test \
783         test/htools-invalid.test \
784         test/htools-multi-group.test \
785         test/htools-no-backend.test \
786         test/htools-rapi.test \
787         test/htools-single-group.test \
788         test/htools-text-backend.test
789
790 python_tests = \
791         doc/examples/rapi_testutils.py \
792         test/ganeti.asyncnotifier_unittest.py \
793         test/ganeti.backend_unittest.py \
794         test/ganeti.bdev_unittest.py \
795         test/ganeti.cli_unittest.py \
796         test/ganeti.client.gnt_cluster_unittest.py \
797         test/ganeti.client.gnt_instance_unittest.py \
798         test/ganeti.daemon_unittest.py \
799         test/ganeti.cmdlib_unittest.py \
800         test/ganeti.compat_unittest.py \
801         test/ganeti.confd.client_unittest.py \
802         test/ganeti.config_unittest.py \
803         test/ganeti.constants_unittest.py \
804         test/ganeti.errors_unittest.py \
805         test/ganeti.hooks_unittest.py \
806         test/ganeti.ht_unittest.py \
807         test/ganeti.http_unittest.py \
808         test/ganeti.hypervisor_unittest.py \
809         test/ganeti.hypervisor.hv_chroot_unittest.py \
810         test/ganeti.hypervisor.hv_fake_unittest.py \
811         test/ganeti.hypervisor.hv_kvm_unittest.py \
812         test/ganeti.hypervisor.hv_lxc_unittest.py \
813         test/ganeti.hypervisor.hv_xen_unittest.py \
814         test/ganeti.impexpd_unittest.py \
815         test/ganeti.jqueue_unittest.py \
816         test/ganeti.locking_unittest.py \
817         test/ganeti.luxi_unittest.py \
818         test/ganeti.masterd.instance_unittest.py \
819         test/ganeti.mcpu_unittest.py \
820         test/ganeti.netutils_unittest.py \
821         test/ganeti.objects_unittest.py \
822         test/ganeti.opcodes_unittest.py \
823         test/ganeti.ovf_unittest.py \
824         test/ganeti.qlang_unittest.py \
825         test/ganeti.query_unittest.py \
826         test/ganeti.rapi.baserlib_unittest.py \
827         test/ganeti.rapi.client_unittest.py \
828         test/ganeti.rapi.resources_unittest.py \
829         test/ganeti.rapi.rlib2_unittest.py \
830         test/ganeti.rapi.testutils_unittest.py \
831         test/ganeti.rpc_unittest.py \
832         test/ganeti.runtime_unittest.py \
833         test/ganeti.serializer_unittest.py \
834         test/ganeti.ssh_unittest.py \
835         test/ganeti.storage_unittest.py \
836         test/ganeti.tools.ensure_dirs_unittest.py \
837         test/ganeti.uidpool_unittest.py \
838         test/ganeti.utils.algo_unittest.py \
839         test/ganeti.utils.filelock_unittest.py \
840         test/ganeti.utils.hash_unittest.py \
841         test/ganeti.utils.io_unittest.py \
842         test/ganeti.utils.log_unittest.py \
843         test/ganeti.utils.mlock_unittest.py \
844         test/ganeti.utils.nodesetup_unittest.py \
845         test/ganeti.utils.process_unittest.py \
846         test/ganeti.utils.retry_unittest.py \
847         test/ganeti.utils.text_unittest.py \
848         test/ganeti.utils.wrapper_unittest.py \
849         test/ganeti.utils.x509_unittest.py \
850         test/ganeti.utils_unittest.py \
851         test/ganeti.workerpool_unittest.py \
852         test/qa.qa_config_unittest.py \
853         test/cfgupgrade_unittest.py \
854         test/docs_unittest.py \
855         test/pycurl_reset_unittest.py \
856         test/tempfile_fork_unittest.py
857 if HAS_FAKEROOT
858 python_tests += test/ganeti.utils.io_unittest-runasroot.py
859 endif
860
861 haskell_tests = htools/test
862
863 dist_TESTS = \
864         test/check-cert-expired_unittest.bash \
865         test/daemon-util_unittest.bash \
866         test/ganeti-cleaner_unittest.bash \
867         test/import-export_unittest.bash \
868         test/cli-test.bash \
869         $(python_tests)
870
871 nodist_TESTS =
872 check_SCRIPTS =
873
874 if WANT_HTOOLSTESTS
875 nodist_TESTS += $(haskell_tests)
876 dist_TESTS += htools/offline-test.sh
877 check_SCRIPTS += htools/hpc-htools $(HS_BUILT_TEST_HELPERS)
878 endif
879
880 TESTS = $(dist_TESTS) $(nodist_TESTS)
881
882 # Environment for all tests
883 PLAIN_TESTS_ENVIRONMENT = \
884         PYTHONPATH=. \
885         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
886         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
887         $(RUN_IN_TEMPDIR)
888
889 # Environment for tests run by automake
890 TESTS_ENVIRONMENT = \
891         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
892
893 all_python_code = \
894         $(dist_sbin_SCRIPTS) \
895         $(python_scripts) \
896         $(pkglib_python_scripts) \
897         $(nodist_pkglib_python_scripts) \
898         $(python_tests) \
899         $(pkgpython_PYTHON) \
900         $(client_PYTHON) \
901         $(hypervisor_PYTHON) \
902         $(rapi_PYTHON) \
903         $(server_PYTHON) \
904         $(pytools_PYTHON) \
905         $(http_PYTHON) \
906         $(confd_PYTHON) \
907         $(masterd_PYTHON) \
908         $(impexpd_PYTHON) \
909         $(utils_PYTHON) \
910         $(watcher_PYTHON) \
911         $(noinst_PYTHON) \
912         $(qa_scripts)
913
914 srclink_files = \
915         man/footer.rst \
916         test/check-cert-expired_unittest.bash \
917         test/daemon-util_unittest.bash \
918         test/ganeti-cleaner_unittest.bash \
919         test/import-export_unittest.bash \
920         test/cli-test.bash \
921         htools/offline-test.sh \
922         htools/cli-tests-defs.sh \
923         $(all_python_code) \
924         $(HS_LIB_SRCS) $(HS_PROG_SRCS)
925
926 check_python_code = \
927         $(BUILD_BASH_COMPLETION) \
928         $(CHECK_IMPORTS) \
929         $(CHECK_HEADER) \
930         $(DOCPP) \
931         $(all_python_code)
932
933 lint_python_code = \
934         ganeti \
935         ganeti/http/server.py \
936         $(dist_sbin_SCRIPTS) \
937         $(python_scripts) \
938         $(pkglib_python_scripts) \
939         $(BUILD_BASH_COMPLETION) \
940         $(CHECK_IMPORTS) \
941         $(CHECK_HEADER) \
942         $(DOCPP) \
943         $(PYTHON_BOOTSTRAP)
944
945 standalone_python_modules = \
946         lib/rapi/client.py \
947         tools/ganeti-listrunner
948
949 pep8_python_code = \
950         ganeti \
951         ganeti/http/server.py \
952         $(dist_sbin_SCRIPTS) \
953         $(python_scripts) \
954         $(pkglib_python_scripts) \
955         $(BUILD_BASH_COMPLETION) \
956         $(CHECK_HEADER) \
957         $(DOCPP) \
958         $(PYTHON_BOOTSTRAP) \
959         qa
960
961 test/daemon-util_unittest.bash: daemons/daemon-util
962
963 test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
964
965 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
966         sed -f $(REPLACE_VARS_SED) < $< > $@
967         chmod +x $@
968
969 devel/upload: devel/upload.in $(REPLACE_VARS_SED)
970         sed -f $(REPLACE_VARS_SED) < $< > $@
971         chmod u+x $@
972
973 daemons/%: daemons/%.in $(REPLACE_VARS_SED)
974         sed -f $(REPLACE_VARS_SED) < $< > $@
975         chmod +x $@
976
977 doc/examples/%: doc/examples/%.in $(REPLACE_VARS_SED)
978         sed -f $(REPLACE_VARS_SED) < $< > $@
979
980 doc/examples/hooks/%: doc/examples/hooks/%.in $(REPLACE_VARS_SED)
981         sed -f $(REPLACE_VARS_SED) < $< > $@
982
983 doc/examples/bash_completion: $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
984         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin
985         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_BASH_COMPLETION) > $@
986
987 doc/%.png: doc/%.dot
988         @test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
989         $(DOT) -Tpng -o $@ $<
990
991 man/footer.man: man/footer.rst
992         @test -n "$(PANDOC)" || \
993           { echo 'pandoc' not found during configure; exit 1; }
994         $(PANDOC) -f rst -t man -o $@ $<
995
996 man/footer.html: man/footer.rst
997         @test -n "$(PANDOC)" || \
998           { echo 'pandoc' not found during configure; exit 1; }
999         $(PANDOC) -f rst -t html -o $@ $<
1000
1001 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1002         lib/build/shell_example_lexer.py
1003         @echo "Checking $< for hardcoded paths..."
1004         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1005           echo "Man page $< has harcoded paths (see above)!" 1>&2 ; \
1006           exit 1; \
1007         fi
1008         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@
1009
1010 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.man
1011         @test -n "$(PANDOC)" || \
1012           { echo 'pandoc' not found during configure; exit 1; }
1013         set -o pipefail ; \
1014         trap 'echo auto-removing $@; rm $@' EXIT; \
1015         $(PANDOC) -s -f rst -t man -A man/footer.man $< | \
1016           sed -e 's/\\@/@/g' > $@; \
1017         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1018         $(CHECK_MAN_DASHES) $@; \
1019         trap - EXIT
1020
1021
1022 man/%.html.in: man/%.gen man/footer.html
1023         @test -n "$(PANDOC)" || \
1024           { echo 'pandoc' not found during configure; exit 1; }
1025         set -o pipefail ; \
1026         $(PANDOC) -s -f rst -t html -A man/footer.html $< | \
1027           sed -e 's/\\@/@/g' > $@
1028
1029 man/%.1: man/%.1.in $(REPLACE_VARS_SED)
1030         sed -f $(REPLACE_VARS_SED) < $< > $@
1031
1032 man/%.7: man/%.7.in $(REPLACE_VARS_SED)
1033         sed -f $(REPLACE_VARS_SED) < $< > $@
1034
1035 man/%.8: man/%.8.in $(REPLACE_VARS_SED)
1036         sed -f $(REPLACE_VARS_SED) < $< > $@
1037
1038 man/%.html: man/%.html.in $(REPLACE_VARS_SED)
1039         sed -f $(REPLACE_VARS_SED) < $< > $@
1040
1041 epydoc.conf: epydoc.conf.in Makefile
1042         sed -e 's#@MODULES@#$(strip $(lint_python_code))#g' < $< > $@
1043
1044 vcs-version:
1045         if test -d .git; then \
1046           git describe > $@; \
1047         elif test ! -f $@ ; then \
1048           echo "Cannot auto-generate $@ file"; exit 1; \
1049         fi
1050
1051 .PHONY: regen-vcs-version
1052 regen-vcs-version:
1053         set -e; \
1054         cd $(srcdir); \
1055         if test -d .git; then \
1056           rm -f vcs-version; \
1057           $(MAKE) vcs-version; \
1058         fi
1059
1060 htools/Ganeti/HTools/Version.hs: htools/Ganeti/HTools/Version.hs.in vcs-version
1061         set -e; \
1062         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1063         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1064
1065 htools/Ganeti/Constants.hs: htools/Ganeti/Constants.hs.in \
1066         lib/constants.py lib/_autoconf.py lib/luxi.py \
1067         $(CONVERT_CONSTANTS) \
1068         | lib/_vcsversion.py
1069         set -e; \
1070         { cat $< ; PYTHONPATH=. $(CONVERT_CONSTANTS); } > $@
1071
1072 lib/_autoconf.py: Makefile | lib/.dir
1073         set -e; \
1074         { echo '# This file is automatically generated, do not edit!'; \
1075           echo '#'; \
1076           echo ''; \
1077           echo '"""Build-time configuration for Ganeti.'; \
1078           echo '';\
1079           echo 'This file is autogenerated by the build process.'; \
1080           echo 'For any changes you need to re-run ./configure (and'; \
1081           echo 'not edit by hand).'; \
1082           echo ''; \
1083           echo '"""'; \
1084           echo ''; \
1085           echo '# pylint: disable=C0301,C0324'; \
1086           echo '# because this is autogenerated, we do not want'; \
1087           echo '# style warnings' ; \
1088           echo ''; \
1089           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1090           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1091           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1092           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1093           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1094           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1095           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1096           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1097           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1098           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1099           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1100           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1101           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1102           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1103           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1104           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1105           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1106           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1107           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1108           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1109           echo "KVM_PATH = '$(KVM_PATH)'"; \
1110           echo "IP_PATH = '$(IP_PATH)'"; \
1111           echo "SOCAT_PATH = '$(SOCAT)'"; \
1112           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1113           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1114           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1115           echo "TOOLSDIR = '$(toolsdir)'"; \
1116           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1117           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1118           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1119           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1120           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1121           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1122           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1123           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1124           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1125           echo "RAPI_USER = '$(RAPI_USER)'"; \
1126           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1127           echo "CONFD_USER = '$(CONFD_USER)'"; \
1128           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1129           echo "NODED_USER = '$(NODED_USER)'"; \
1130           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1131           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1132           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1133           if [ "$(HTOOLS)" ]; then \
1134             echo "HTOOLS = True"; \
1135           else \
1136             echo "HTOOLS = False"; \
1137           fi; \
1138           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1139           echo "PY_CONFD = $(PY_CONFD)"; \
1140           echo "HS_CONFD = $(HS_CONFD)"; \
1141           echo "XEN_CMD = '$(XEN_CMD)'"; \
1142         } > $@
1143
1144 lib/_vcsversion.py: Makefile vcs-version | lib/.dir
1145         set -e; \
1146         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1147         { echo '# This file is automatically generated, do not edit!'; \
1148           echo '#'; \
1149           echo ''; \
1150           echo '"""Build-time VCS version number for Ganeti.'; \
1151           echo '';\
1152           echo 'This file is autogenerated by the build process.'; \
1153           echo 'For any changes you need to re-run ./configure (and'; \
1154           echo 'not edit by hand).'; \
1155           echo ''; \
1156           echo '"""'; \
1157           echo ''; \
1158           echo '# pylint: disable=C0301,C0324'; \
1159           echo '# because this is autogenerated, we do not want'; \
1160           echo '# style warnings' ; \
1161           echo ''; \
1162           echo "VCS_VERSION = '$$VCSVER'"; \
1163         } > $@
1164
1165 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1166         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1167
1168 $(REPLACE_VARS_SED): Makefile
1169         set -e; \
1170         { echo 's#@PREFIX@#$(prefix)#g'; \
1171           echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
1172           echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
1173           echo 's#@BINDIR@#$(bindir)#g'; \
1174           echo 's#@SBINDIR@#$(sbindir)#g'; \
1175           echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1176           echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1177           echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1178           echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1179           echo 's#@CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1180           echo 's#@CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1181           echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1182           echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1183           echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
1184           echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1185           echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
1186           echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
1187           echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
1188           echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1189           echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1190           echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1191           echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1192           echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1193           echo 's#@CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1194         } > $@
1195
1196 # Using deferred evaluation
1197 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1198 daemons/ganeti-watcher: MODULE = ganeti.watcher
1199 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1200 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1201 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/%,%,$@)
1202
1203 $(PYTHON_BOOTSTRAP): Makefile | $(all_dirfiles)
1204         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1205         set -e; \
1206         { echo '#!/usr/bin/python'; \
1207           echo '# This file is automatically generated, do not edit!'; \
1208           echo "# Edit $(MODULE) instead."; \
1209           echo; \
1210           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1211           echo; \
1212           echo '# pylint: disable=C0103'; \
1213           echo '# C0103: Invalid name'; \
1214           echo; \
1215           echo 'import sys'; \
1216           echo 'import $(MODULE) as main'; \
1217           echo; \
1218           echo '# Temporarily alias commands until bash completion'; \
1219           echo '# generator is changed'; \
1220           echo 'if hasattr(main, "commands"):'; \
1221           echo '  commands = main.commands # pylint: disable=E1101'; \
1222           echo 'if hasattr(main, "aliases"):'; \
1223           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1224           echo; \
1225           echo 'if __name__ == "__main__":'; \
1226           echo '  sys.exit(main.Main())'; \
1227         } > $@
1228         chmod u+x $@
1229
1230 $(HS_BUILT_TEST_HELPERS): Makefile
1231         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1232         set -e; \
1233         { echo '#!/bin/sh'; \
1234           echo '# This file is automatically generated, do not edit!'; \
1235           echo "# Edit Makefile.am instead."; \
1236           echo; \
1237           echo "HTOOLS=$(TESTROLE) exec ./htools/hpc-htools \"\$$@\""; \
1238         } > $@
1239         chmod u+x $@
1240
1241 # We need to create symlinks because "make distcheck" will not install Python
1242 # files when building.
1243 stamp-srclinks: Makefile | $(all_dirfiles)
1244         set -e; \
1245         for i in $(srclink_files); do \
1246                 if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1247                         $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1248                 fi; \
1249         done
1250         touch $@
1251
1252 .PHONY: ganeti
1253 ganeti:
1254         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1255
1256 .PHONY: check-dirs
1257 check-dirs: $(BUILT_SOURCES)
1258         @set -e; \
1259         find . -type d \( \( -name . \) -o \( \
1260                 -name .git -o \
1261                 -name autom4te.cache \
1262                 \) -prune -o -print \) | { \
1263                 error=; \
1264                 while read dir; do \
1265                         case "$$dir" in \
1266                                 $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1267                                 *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1268                         esac; \
1269                 done; \
1270                 for dir in $(DIRS); do \
1271                         if ! test -d "$$dir"; then \
1272                                 echo "Directory $$dir listed in DIRS does not exist" >&2; \
1273                                 error=1; \
1274                         fi \
1275                 done; \
1276                 if test -n "$$error"; then exit 1; else exit 0; fi; \
1277         }
1278
1279 .PHONY: check-local
1280 check-local: check-dirs $(BUILT_SOURCES)
1281         $(CHECK_PYTHON_CODE) $(check_python_code)
1282         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1283         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1284         $(CHECK_NEWS) < $(top_srcdir)/NEWS
1285         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1286         expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1287         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1288                 echo "Incorrect version in README, expected $$expver"; \
1289                 exit 1; \
1290         fi; \
1291         for file in doc/iallocator.rst doc/hooks.rst; do \
1292                 if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1293                         "Documents Ganeti version $$expver"; then \
1294                         echo "Incorrect version in $$file, expected $$expver"; \
1295                         exit 1; \
1296                 fi; \
1297         done
1298
1299 .PHONY: hs-check
1300 hs-check: htools/test htools/hpc-htools $(HS_BUILT_TEST_HELPERS)
1301         @rm -f test.tix
1302         ./htools/test
1303         HBINARY="./htools/hpc-htools" ./htools/offline-test.sh
1304
1305 # E111: indentation is not a multiple of four
1306 # E261: at least two spaces before inline comment
1307 # E501: line too long (80 characters)
1308 PEP8_IGNORE = E111,E261,E501
1309
1310 # For excluding pep8 expects filenames only, not whole paths
1311 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1312
1313 .PHONY: lint
1314 lint: $(BUILT_SOURCES)
1315         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1316         if test -z "$(PEP8)"; then \
1317                 echo '"pep8" not found during configure' >&2; \
1318         else \
1319                 $(PEP8) --repeat --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1320                         $(pep8_python_code); \
1321         fi
1322         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1323         cd $(top_srcdir)/qa && \
1324           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1325           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1326
1327 .PHONY: hlint
1328 hlint: $(HS_BUILT_SRCS) htools/lint-hints.hs
1329         if tty -s; then C="-c"; else C=""; fi; \
1330         hlint --report=doc/hs-lint.html --cross $$C \
1331           --ignore "Use first" \
1332           --ignore "Use comparing" \
1333           --ignore "Use on" \
1334           --ignore "Use Control.Exception.catch" \
1335           --ignore "Reduce duplication" \
1336           --hint htools/lint-hints \
1337           $(filter-out htools/Ganeti/THH.hs,$(HS_LIB_SRCS))
1338
1339 # a dist hook rule for updating the vcs-version file; this is
1340 # hardcoded due to where it needs to build the file...
1341 dist-hook:
1342         $(MAKE) regen-vcs-version && \
1343         rm -f $(top_distdir)/vcs-version && \
1344         cp -p $(srcdir)/vcs-version $(top_distdir)
1345
1346 # a distcheck hook rule for catching revision control directories
1347 distcheck-hook:
1348         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1349                 echo "Found revision control files in final archive." 1>&2; \
1350                 exit 1; \
1351         fi
1352         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1353                 echo "Found Python byte code in final archive." 1>&2; \
1354                 exit 1; \
1355         fi
1356         if find $(top_distdir) -name '*~' | grep .; then \
1357                 echo "Found backup files in final archive." 1>&2; \
1358                 exit 1; \
1359         fi
1360 # Empty files or directories should not be distributed. They can cause
1361 # unnecessary warnings for packagers. Directories used by automake during
1362 # distcheck must be excluded.
1363         if find $(top_distdir) -empty -and -not \( \
1364                         -path $(top_distdir)/_build -or \
1365                         -path $(top_distdir)/_inst \) | grep .; then \
1366                 echo "Found empty files or directories in final archive." 1>&2; \
1367                 exit 1; \
1368         fi
1369         if test -n "$(BUILD_RELEASE)" && \
1370            grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1371                 echo "Found unreleased version in NEWS." >&2; \
1372                 exit 1; \
1373         fi
1374
1375 # When building a release, stricter checks should be used
1376 distcheck-release dist-release: export BUILD_RELEASE = 1
1377 distcheck-release: distcheck
1378
1379 dist-release: dist
1380         set -e; \
1381         for i in $(DIST_ARCHIVES); do \
1382                 echo -n "Checking $$i ... "; \
1383                 autotools/check-tar < $$i; \
1384                 echo OK; \
1385         done
1386
1387 install-exec-local:
1388         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1389           "$(DESTDIR)${localstatedir}/log/ganeti" \
1390           "$(DESTDIR)${localstatedir}/run/ganeti"
1391
1392 # To avoid conflicts between directory names and other targets, a file inside
1393 # the directory is used to ensure its existence.
1394 %.dir:
1395         @mkdir_p@ $* && touch $@
1396
1397 .PHONY: apidoc
1398 if WANT_HTOOLSAPIDOC
1399 apidoc: py-apidoc hs-apidoc
1400 else
1401 apidoc: py-apidoc
1402 endif
1403
1404 .PHONY: py-apidoc
1405 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(BUILT_SOURCES)
1406         $(RUN_IN_TEMPDIR) epydoc -v \
1407                 --conf $(CURDIR)/epydoc.conf \
1408                 --output $(CURDIR)/$(APIDOC_PY_DIR)
1409
1410 .PHONY: hs-apidoc
1411 hs-apidoc: $(HS_BUILT_SRCS)
1412         @test -n "$(HSCOLOUR)" || \
1413             { echo 'HsColour' not found during configure; exit 1; }
1414         @test -n "$(HADDOCK)" || \
1415             { echo 'haddock' not found during configure; exit 1; }
1416         rm -rf $(APIDOC_HS_DIR)/*
1417         @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/HTools/Program
1418         @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/Confd
1419         $(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1420         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1421         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/Confd/hscolour.css
1422         set -e ; \
1423         cd htools; \
1424         if [ "$(HTOOLS_NOCURL)" ]; \
1425         then OPTGHC="--optghc=$(HTOOLS_NOCURL)"; \
1426         else OPTGHC=""; \
1427         fi; \
1428         if [ "$(HTOOLS_PARALLEL3)" ]; \
1429         then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_PARALLEL3)"; \
1430         fi; \
1431         RELSRCS="$(HS_LIB_SRCS:htools/%=%)  $(HS_BUILT_SRCS:htools/%=%)"; \
1432         for file in $$RELSRCS; do \
1433                 hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1434                 $(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1435         done ; \
1436         $(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1437                 -t ganeti-htools -p haddock-prologue \
1438                 --source-module="%{MODULE/.//}.html" \
1439                 --source-entity="%{MODULE/.//}.html#%{NAME}" \
1440                 $$OPTGHC \
1441                 $(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:htools/%=%))
1442
1443 .PHONY: TAGS
1444 TAGS: $(BUILT_SOURCES)
1445         rm -f TAGS
1446         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1447           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1448           -path './qa/*.py' | \
1449           etags -l python -
1450
1451 .PHONY: coverage
1452 if WANT_HTOOLS
1453 coverage: py-coverage hs-coverage
1454 else
1455 coverage: py-coverage
1456 endif
1457
1458 .PHONY: py-coverage
1459 py-coverage: $(BUILT_SOURCES) $(python_tests)
1460         set -e; \
1461         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1462         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1463         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1464         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/gen-coverage \
1465         $(python_tests)
1466
1467 .PHONY: hs-coverage
1468 hs-coverage: $(haskell_tests) htools/hpc-htools
1469         rm -f *.tix && $(MAKE) hs-check
1470         @mkdir_p@ $(COVERAGE_HS_DIR)
1471         hpc combine $(HPCEXCL) test.tix hpc-htools.tix > coverage-htools.tix
1472         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-htools.tix
1473         hpc report coverage-htools.tix
1474         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1475
1476 # Special "kind-of-QA" target for htools, needs special setup (all
1477 # tools compiled with -fhpc)
1478 .PHONY: live-test
1479 live-test: all
1480         set -e ; \
1481         cd htools; \
1482         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1483         rm -f *.tix *.mix; \
1484         ./live-test.sh; \
1485         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:htools/%=%)) \
1486           --output=live-test.tix ; \
1487         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1488         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1489                 --srcdir=.. $(HPCEXCL) ; \
1490         hpc report --srcdir=.. live-test $(HPCEXCL)
1491
1492 commit-check: distcheck lint apidoc
1493
1494 -include ./Makefile.local
1495
1496 # vim: set noet :